// BMFBioUPIDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BMFBioUPIDemo.h"
#include "BMFBioUPIDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include "io.h"
#include "fcntl.h"
#include <sys/stat.h>



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBMFBioUPIDemoDlg dialog

CBMFBioUPIDemoDlg::CBMFBioUPIDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBMFBioUPIDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBMFBioUPIDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBMFBioUPIDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBMFBioUPIDemoDlg)
	DDX_Control(pDX, IDC_TRANING, m_Training);
	DDX_Control(pDX, IDC_ENROLL, m_Enroll);
	DDX_Control(pDX, IDC_COMP1TON, m_Comp1toN);
	DDX_Control(pDX, IDC_COMP1TO1, m_Comp1to1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBMFBioUPIDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CBMFBioUPIDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COMP1TO1, OnComp1to1)
	ON_BN_CLICKED(IDC_COMP1TON, OnComp1ton)
	ON_BN_CLICKED(IDC_ENROLL, OnEnroll)
	ON_BN_CLICKED(IDC_TRANING, OnTraning)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_TEMP_LESS, OnTempLess)
	ON_BN_CLICKED(IDC_TEMP_MORE, OnTempMore)
	ON_BN_CLICKED(IDC_FILE_BMP, OnFileBmp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBMFBioUPIDemoDlg message handlers

BOOL CBMFBioUPIDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_IsTraining = FALSE;
	m_IsEnroll= FALSE;
	m_IsComp1to1= FALSE;
	m_IsComp1toN= FALSE;

//	SetDlgItemInt(IDC_NUMLEVEL, dev.GetSensitiveLevel());

	//	    
	TreatStatus = TRUE;
	
//	s_DoEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
//	SetEvent(s_DoEvent);
	ScanThread = AfxBeginThread(ThreadScanner,this);
	//int prior = GetThreadPriority(ScanThread->m_hThread  );
	//SetThreadPriority(ScanThread->m_hThread, 2);
	//prior = GetThreadPriority(ScanThread->m_hThread  );


//	if ( DevHand1 >= 0 ) {
//		TreatStatus1 = TRUE;
//		ScanThread1 = AfxBeginThread(ThreadScanner1,this);
//	}

	UpdateData(FALSE);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBMFBioUPIDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBMFBioUPIDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBMFBioUPIDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBMFBioUPIDemoDlg::OnComp1to1() 
{
// TODO: Add your control notification handler code here
m_IsComp1to1= TRUE;

m_IsTraining = FALSE;
m_IsEnroll = FALSE;	
m_IsComp1toN= FALSE;


SetDlgItemText(IDC_STATUS,    "Verification information");
SetDlgItemText(IDC_STATUSINFO,"Please, put your finger on the scanner");
}

void CBMFBioUPIDemoDlg::OnComp1ton() 
{
// TODO: Add your control notification handler code here
m_IsComp1toN= TRUE;

m_IsTraining = FALSE;
m_IsEnroll = FALSE;	
m_IsComp1to1= FALSE;
counter = 0;
}

void CBMFBioUPIDemoDlg::OnEnroll() 
{
// TODO: Add your control notification handler code here
m_IsEnroll = TRUE;	

m_IsTraining = FALSE;
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;

counter = 0;
status  = 0;

SetDlgItemText(IDC_STATUS,    "Enrollment information");
SetDlgItemText(IDC_STATUSINFO,"Please, put your finger on the scanner");
}

void CBMFBioUPIDemoDlg::OnTraning() 
{
// TODO: Add your control notification handler code here

//int ufisReadCard(unsigned char* buf, int buffersize, int* rbyte)

m_IsTraining = TRUE;

m_IsEnroll = FALSE;	
m_IsComp1to1= FALSE;
m_IsComp1toN= FALSE;

SetDlgItemText(IDC_STATUS,    "");
SetDlgItemText(IDC_STATUSINFO,"");
}



void CBMFBioUPIDemoDlg::MyPaint(void)
{
	short	color;

	CWnd* pWnd = GetDlgItem(IDC_IMAGE);
	CClientDC pControlDC(pWnd);
	RECT	rect;

	int	deltaX=1;
	int	deltaY=4;

	if  ( pimg == NULL )	return;


	pWnd->GetWindowRect(&rect);

	rect.left=5; 
	rect.top=15;
	rect.bottom = rect.top  + Himg-deltaY;
	rect.right  = rect.left + Wimg-deltaX;

	CBitmap * oldBitmap;
	CRect clientRect;

	CDC * m_pdcDisplayMemory = new CDC;
	CBitmap * m_pBitmap = new CBitmap;
			
	if (m_pdcDisplayMemory->GetSafeHdc() == NULL) 
	{
		m_pdcDisplayMemory->CreateCompatibleDC(&pControlDC);
		m_pBitmap->CreateCompatibleBitmap(
				&pControlDC
				,Wimg-deltaX 
				,Himg-deltaY
				);

		oldBitmap = m_pdcDisplayMemory->SelectObject(m_pBitmap);
	}
	int x0 = rect.left;
	int y0 = rect.top;
	int Beg=0;
		
	for(unsigned int j=0; j<(unsigned)(Himg-deltaY);j++)
	{
		for(unsigned int i=0;i<(unsigned)(Wimg-deltaX);i++)
		{
			color = pimg[Beg+i+j*Wimg];
			m_pdcDisplayMemory->SetPixel(i,j,RGB(color,color,color)); 
		}
	}

	pControlDC.StretchBlt(x0, y0, 
			Wimg-deltaX , 
			Himg-deltaY, 
			m_pdcDisplayMemory, 
			0, 0, 
			Wimg-deltaX , 
			Himg-deltaY, 
			SRCCOPY);

	delete m_pdcDisplayMemory;
	delete m_pBitmap;
		
}

void CBMFBioUPIDemoDlg::OnOK() 
{
	// TODO: Add extra validation here

	TreatStatus = FALSE;
	if ( ScanThread !=NULL ) {
		WaitForSingleObject(ScanThread->m_hThread,INFINITE);
	}
	
	CDialog::OnOK();
}



void CBMFBioUPIDemoDlg::OnTest() 
{
//int	ret;

//ret = dev.SendCommand(0x99);

//dev.ufisCloseDevice();
//ret = dev.ufisOpenDeviceType(TYPESCANNER_UFIS210,0xffffffff);

}

void CBMFBioUPIDemoDlg::OnTempLess() 
{
	// TODO: Add your control notification handler code here
//	dev.ufisTempContr(2);
	
}

void CBMFBioUPIDemoDlg::OnTempMore() 
{
	// TODO: Add your control notification handler code here
//	dev.ufisTempContr(1);
	
}

void CBMFBioUPIDemoDlg::OnFileBmp() 
{
	// TODO: Add your control notification handler code here
	int	fh, len;
	unsigned char * ptr;

	fh = _open("image.bmp", O_CREAT | O_WRONLY | O_BINARY | O_TRUNC, 0666 );
	if ( fh == - 1 )	return;

	ptr = ufisConvertToBmp8(DevHand);
	len = ufisGetLengthBmp8(DevHand);

	_write(fh,(void *)ptr, len);


	_close(fh);
}

